"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantInterpretationLogInject(ProtocolElement):
    """
    Record for Variant Interpretation Log as part of data intake for CVA
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "metadata",
        "variantInterpretationLog",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import cva as cva_1_5_0
        from protocols.protocol_7_4 import reports as reports_6_1_0

        return {
            "metadata": cva_1_5_0.InjectionMetadata,
            "variantInterpretationLog": reports_6_1_0.VariantInterpretationLog,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import cva as cva_1_5_0
        from protocols.protocol_7_4 import reports as reports_6_1_0

        return {
            "org.gel.models.cva.avro.InjectionMetadata": cva_1_5_0.InjectionMetadata,
            "org.gel.models.report.avro.VariantInterpretationLog": reports_6_1_0.VariantInterpretationLog,
            "org.gel.models.cva.avro.VariantInterpretationLogInject": cva_1_5_0.VariantInterpretationLogInject,
        }

    __slots__ = [
        "metadata",
        "variantInterpretationLog",
    ]

    def __init__(
        self,
        metadata,
        variantInterpretationLog,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_0.VariantInterpretationLogInject model.

        :param metadata:
            Metadata on the variant interpretation log
        :type metadata: InjectionMetadata
        :param variantInterpretationLog:
            The variant interpretation log
        :type variantInterpretationLog: VariantInterpretationLog
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
